dofile'UniEdit\guiEdit.lua'
snapToGrid()
local mapNearFlag={0,0, --  
			4,0,
			16,0,
			20,0,
			10,1,
			2,1,
			8,1,
			30,2,
			22,3,
			14,4,
			28,5,
			26,6,
			6,7,
			12,8,
			24,9,
			18,10}
local mapCorForWall={-1,-1,1,-1,1,1,-1,1} --      
local dlg
local wallP={}
wallP.tile=0
wallP.var=-1 -- -1  
wallP.flag=0
wallP.hp=0
wallP.mod=0
wallP.mod1=0 -- 0  1  2 
wallP.dir=0


fileLoad('UniEdit/img/wallBut.tar.bz2') -- 
imgLoad('UniEditWall0.png','UniEditWall0')
imgLoad('UniEditWall1.png','UniEditWall1')
imgLoad('UniEditWall2.png','UniEditWall2')
imgLoad('UniEditWall3.png','UniEditWall3')
imgLoad('UniEditWall4.png','UniEditWall4')
imgLoad('UniEditWall5.png','UniEditWall5')
imgLoad('UniEditWall6.png','UniEditWall6')
imgLoad('UniEditWall7.png','UniEditWall7')
imgLoad('UniEditWall8.png','UniEditWall8')
imgLoad('UniEditWall9.png','UniEditWall9')
imgLoad('UniEditWall10.png','UniEditWall10')

imgLoad('UniEditWall0Dis.png','UniEditWall0Dis')
imgLoad('UniEditWall1Dis.png','UniEditWall1Dis')
imgLoad('UniEditWall2Dis.png','UniEditWall2Dis')
imgLoad('UniEditWall3Dis.png','UniEditWall3Dis')
imgLoad('UniEditWall4Dis.png','UniEditWall4Dis')
imgLoad('UniEditWall5Dis.png','UniEditWall5Dis')
imgLoad('UniEditWall6Dis.png','UniEditWall6Dis')
imgLoad('UniEditWall7Dis.png','UniEditWall7Dis')
imgLoad('UniEditWall8Dis.png','UniEditWall8Dis')
imgLoad('UniEditWall9Dis.png','UniEditWall9Dis')
imgLoad('UniEditWall10Dis.png','UniEditWall10Dis')



function setWall()
	local x,y=xGrid,yGrid
	x=x-x%23
	y=y-y%23
	if (x%2==0 and y%2==0) or (x%2==1 and y%2==1) then
		local dir,flag,var,t,mod1
		mod1=wallP.mod1
		if wallP.mod1~=2 then
			flag=getNearWallFlags(x,y) --  
			for i=1,#mapNearFlag,2 do --    
				if mapNearFlag[i]==flag then dir=mapNearFlag[i+1] end
			end
		else
			dir=wallP.dir
		end
		if wallP.flag~=192 then
			if wallP.var==-1 then
					var=math.random(0,mapMaxVari(wallP.tile,dir)-1)
				else
					var=wallP.var
			end
		end
		local mayWall=mapSet(wallP.tile,x,y,dir,wallP.flag,var,0,wallP.hp)
		if mod1==0 then
			local walls=getNearWall(mayWall)
			for i=1,#walls do --   
				flag=getNearWallFlags(mapPos(walls[i]))
				for j=1,#mapNearFlag,2 do
					if mapNearFlag[j]==flag then
						setPtrByte(walls[i],0, mapNearFlag[j+1])
						t=mapInfo(walls[i])
						if t.vari>mapMaxVari(t.tile,t.dir)-1 then setPtrByte(walls[i],2,0) end
					end
				end
			end
		end
	end
end

function getNearWallFlags(x,y)
	local c=0 --        
	local a
	for i=1,8,2 do
		local x1=x+23*mapCorForWall[i]
		local y1=y+23*mapCorForWall[i+1]
		if mapGet(x1,y1)~=nil then c=c+2^((i+1)/2) end
	end
	return c
end


function getNearWall(x)
	local x,y=mapPos(x)
	local t={}
	for i=1,8,2 do
		local x1=x+23*mapCorForWall[i]
		local y1=y+23*mapCorForWall[i+1]
		a=mapGet(x1,y1)
		if a~=nil then table.insert(t,a)  end
	end
	return t
end


function mapPos(a)
	local t=mapInfo(a)
	local x=t.x * 23
	local y=t.y * 23
	return x,y
end

function wallDel()
	local x,y=xGrid,yGrid
	x=x-x%23
	y=y-y%23
	mapDel(x,y)
end

function wallInform()
	local x,y=xGrid,yGrid
	x=x-x%23
	y=y-y%23
	local a=mapGet(x,y)
	if a~=nil then print(json.encode(mapInfo(a))) end
end



function wallDlg()
	if dlg~=nil then return end
	local t,listWall,textTile,setBut,delBut,infBut,avtomBut,poluAvtomBut,RuchBut,razrurBut,OknoBut,secretBut,okonoRazBut
	local butDir={}
	local ti=table.insert
	local width=410
	local height=310
	dlg={x=0,y=0,w=width,h=height,status="ENABLED",alpha=true}
	t={ -- 
		type="PUSHBUTTON",
		status="ENABLED+IMAGE",
		style="MOUSETRACK",
		x=width-50,y=height-25,w=45,h=25,
		offsetX=0,offsetY=-1,
		selectedImage="UIButtonSmLit";
		hiliteImage="UIButtonSmLit";
		image="UIButtonSm";
		disabledImage="UIButtonSmDis";
		textColor='#E6A541';
		text=".",
		onClick=function(a,b)
			wndClose(b) dlg=nil
			wallP.mod=0
			wallP.mod1=0
			wallP.hp=0
			wallP.flag=0
			wallP.dir=0
			wallP.flag=0
		end
	}
	ti(dlg,t)
	listWall={ --  
		type="SCROLLLISTBOX",
		status="ENABLED",
		style="MOUSETRACK",
		x=10,y=10,w=160,h=280,
		bgcolor='TRANSPARENT',
		hiliteColor="#E6A541",
		disabledColor="#E6A541",
		enabledColor="#E6A541",
		textColor="#007F7F",
		selectedColor="#000096",
		maxLines=74,
		onSelChange=function (me,parent,idx)
			wallP.tile=idx
			wndSetText(textTile,mapNameByTile(idx) ..'('..idx..')')
		end
	}
	ti(dlg,listWall)
	textTile={
		type="ENTRYFIELD",
		status="ENABLED+ONE_LINE",
		style="MOUSETRACK",
		x=175,y=10,w=155,h=15,
		bgcolor='TRANSPARENT',
		textColor='#E6A541';
		textColor='#E6A541';
		selectedColor="#3F007F";
		maxLen=100
		}
	ti(dlg,textTile)
	setBut={
		type="PUSHBUTTON",
		status="ENABLED+IMAGE",
		style="MOUSETRACK",
		x=width-110,y=height-25,w=45,h=25,
		offsetX=0,offsetY=-1,
		selectedImage="UIButtonSmLit",
		hiliteImage="UIButtonSmLit",
		image="UIButtonSm",
		disabledImage="UIButtonSmDis",
		textColor='#E6A541',
		text=".",
		tooltip=' ',
		onClick=function(a,b)
			if wallP.mod==1 then
				wallP.mod=0
				wndUnGrabMouse(b)
				wndSetAttr(a,'textColor',"#E6A541")
			else
				wallP.mod=1
				wndGrabMouse(b)
				wndSetAttr(infBut,'textColor',"#E6A541")
				wndSetAttr(delBut,'textColor',"#E6A541")
				wndSetAttr(a,'textColor',"#FF0000")
			end
		end
		}
	ti(dlg,setBut)
	delBut={
		type="PUSHBUTTON",
		status="ENABLED+IMAGE",
		style="MOUSETRACK",
		x=width-170,y=height-25,w=45,h=25,
		offsetX=0,offsetY=-1,
		selectedImage="UIButtonSmLit",
		hiliteImage="UIButtonSmLit",
		image="UIButtonSm",
		disabledImage="UIButtonSmDis",
		textColor='#E6A541',
		text=".",
		tooltip=' ',
		onClick=function(a,b)
			if wallP.mod==2 then
				wallP.mod=0
				wndUnGrabMouse(b)
				wndSetAttr(a,'textColor',"#E6A541")

			else
				wallP.mod=2
				wndGrabMouse(b)
				wndSetAttr(infBut,'textColor',"#E6A541")
				wndSetAttr(setBut,'textColor',"#E6A541")
				wndSetAttr(a,'textColor',"#FF0000")
			end
		end
		}
	ti(dlg,delBut)
	infBut={
		type="PUSHBUTTON",
		status="ENABLED+IMAGE",
		style="MOUSETRACK",
		x=width-230,y=height-25,w=45,h=25,
		offsetX=0,offsetY=-1,
		selectedImage="UIButtonSmLit",
		hiliteImage="UIButtonSmLit",
		image="UIButtonSm",
		disabledImage="UIButtonSmDis",
		textColor='#E6A541',
		text=".",
		tooltip='  ',
		onClick=function(a,b)
			if wallP.mod==3 then
				wallP.mod=0
				wndUnGrabMouse(b)
				wndSetAttr(a,'textColor',"#E6A541")

			else
				wallP.mod=3
				wndGrabMouse(b)
				wndSetAttr(delBut,'textColor',"#E6A541")
				wndSetAttr(setBut,'textColor',"#E6A541")
				wndSetAttr(a,'textColor',"#FF0000")
			end
		end
	}
	ti(dlg,infBut)
	avtomBut={
		type = "PUSHBUTTON",
		x=175,y=35,w=70,h=22,
		offsetX=0,offsetY=0,
		status="ENABLED+IMAGE",
		style = "MOUSETRACK",
		selectedImage="UIButtonLgLit",
		hiliteImage="UIButtonLg",
		image="UIButtonLg",
		textColor='#FF0000',
		text="",
		tooltip=' ',
		onClick=function(a)
			wallP.mod1=0
			wndSetAttr(RuchBut,'textColor',"#E6A541")
			wndSetAttr(poluAvtomBut,'textColor',"#E6A541")
			wndSetAttr(a,'textColor',"#FF0000")
			for i=1,11 do
				wndButtonSwitchOff(butDir[i])
			end
		end
	}
	ti(dlg,avtomBut)
	poluAvtomBut={
		type = "PUSHBUTTON",
		x=250,y=35,w=70,h=22,
		offsetX=0,offsetY=0,
		status="ENABLED+IMAGE",
		style = "MOUSETRACK",
		selectedImage="UIButtonLgLit",
		hiliteImage="UIButtonLg",
		image="UIButtonLg",
		textColor='#E6A541',
		text=". ",
		tooltip=' ',
		onClick=function(a)
			wallP.mod1=1
			wndSetAttr(RuchBut,'textColor',"#E6A541")
			wndSetAttr(avtomBut,'textColor',"#E6A541")
			wndSetAttr(a,'textColor',"#FF0000")
			for i=1,11 do
				wndButtonSwitchOff(butDir[i])
			end
		end
	}
	ti(dlg,poluAvtomBut)
	RuchBut={
		type = "PUSHBUTTON",
		x=325,y=35,w=70,h=22,
		offsetX=0,offsetY=0,
		status="ENABLED+IMAGE",
		style = "MOUSETRACK",
		selectedImage="UIButtonLgLit",
		hiliteImage="UIButtonLg",
		image="UIButtonLg",
		textColor='#E6A541',
		text="",
		tooltip=' ',
		onClick=function(a)
			wallP.mod1=2
			wndSetAttr(poluAvtomBut,'textColor',"#E6A541")
			wndSetAttr(avtomBut,'textColor',"#E6A541")
			wndSetAttr(a,'textColor',"#FF0000")
			wallP.dir=0
			for i=2,11 do
				wndButtonSwitchOn(butDir[i])
				wndButtonSwitchOff(butDir[1])
			end
		end
	}
	ti(dlg,RuchBut)
	OknoBut={
		type = "PUSHBUTTON",
		x=325,y=65,w=70,h=22,
		offsetX=0,offsetY=0,
		status="ENABLED+IMAGE",
		style = "MOUSETRACK",
		selectedImage="UIButtonLgLit",
		hiliteImage="UIButtonLg",
		image="UIButtonLg",
		textColor='#E6A541',
		text="",
		tooltip=' ',
		onClick=function(a)
			if wallP.flag==192 then
				wallP.flag=0 wndSetAttr(a,'textColor',"#E6A541")
				wallP.hp=0
			else
				wallP.flag=192
				wallP.hp=0
				wndSetAttr(okonoRazBut,'textColor',"#E6A541")
				wndSetAttr(secretBut,'textColor',"#E6A541")
				wndSetAttr(razrurBut,'textColor',"#E6A541")
				wndSetAttr(a,'textColor',"#FF0000")
			end
		end
	}
	ti(dlg,OknoBut)
	razrurBut={
		type = "PUSHBUTTON",
		x=250,y=65,w=70,h=22,
		offsetX=0,offsetY=0,
		status="ENABLED+IMAGE",
		style = "MOUSETRACK",
		selectedImage="UIButtonLgLit",
		hiliteImage="UIButtonLg",
		image="UIButtonLg",
		textColor='#E6A541',
		text="",
		tooltip='  ',
		onClick=function(a)
			if wallP.flag==8 then
				wallP.flag=0
				wallP.hp=0
				wndSetAttr(a,'textColor',"#E6A541")
			else
				wallP.flag=8
				wallP.hp=1
				wndSetAttr(okonoRazBut,'textColor',"#E6A541")
				wndSetAttr(secretBut,'textColor',"#E6A541")
				wndSetAttr(OknoBut,'textColor',"#E6A541")
				wndSetAttr(a,'textColor',"#FF0000")
			end
		end
	}
	ti(dlg,razrurBut)
	secretBut={
		type = "PUSHBUTTON",
		x=175,y=65,w=70,h=22,
		offsetX=0,offsetY=0,
		status="IMAGE+ENABLED",
		style = "MOUSETRACK",
		selectedImage="UIButtonLgLit",
		hiliteImage="UIButtonLg",
		image="UIButtonLg",
		disabledImage='UIButtonLgDis',
		textColor='#E6A541',
		text="",
		tooltip='  ',
		onClick=function(a)
			if wallP.flag==4 then
				wallP.flag=0
				wallP.hp=0
				wndSetAttr(a,'textColor',"#E6A541")
			else
				wallP.flag=4
				wallP.hp=0
				wndSetAttr(okonoRazBut,'textColor',"#E6A541")
				wndSetAttr(razrurBut,'textColor',"#E6A541")
				wndSetAttr(OknoBut,'textColor',"#E6A541")
				wndSetAttr(a,'textColor',"#FF0000")
			end
		end
	}
	ti(dlg,secretBut)
	okonoRazBut={
		type = "PUSHBUTTON",
		x=325,y=95,w=70,h=22,
		offsetX=0,offsetY=0,
		status="IMAGE+ENABLED",
		style = "MOUSETRACK",
		selectedImage="UIButtonLgLit",
		hiliteImage="UIButtonLg",
		image="UIButtonLg",
		disabledImage='UIButtonLgDis',
		textColor='#E6A541',
		text=".  .",
		tooltip='    ',
		onClick=function(a)
			if wallP.flag==200 then
				wallP.flag=0
				wallP.hp=0
				wndSetAttr(a,'textColor',"#E6A541")
			else
				wallP.flag=200
				wallP.hp=1
				wndSetAttr(secretBut,'textColor',"#E6A541")
				wndSetAttr(razrurBut,'textColor',"#E6A541")
				wndSetAttr(OknoBut,'textColor',"#E6A541")
				wndSetAttr(a,'textColor',"#FF0000")
			end
		end
	}
	ti(dlg,okonoRazBut)


	--  
	t={
		type = "PUSHBUTTON",
		x=225,y=95,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall0Dis",
		hiliteImage="UniEditWall0",
		image="UniEditWall0",
		disabledImage='UniEditWall0Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=0
		end
	}
	ti(butDir,t)
		t={
		type = "PUSHBUTTON",
		x=255,y=95,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall1Dis",
		hiliteImage="UniEditWall1",
		image="UniEditWall1",
		disabledImage='UniEditWall1Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=1
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=285,y=95,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall2Dis",
		hiliteImage="UniEditWall2",
		image="UniEditWall2",
		disabledImage='UniEditWall2Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=2
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=270,y=225,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall3Dis",
		hiliteImage="UniEditWall3",
		image="UniEditWall3",
		disabledImage='UniEditWall3Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=3
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=240,y=225,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall4Dis",
		hiliteImage="UniEditWall4",
		image="UniEditWall4",
		disabledImage='UniEditWall4Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=4
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=240,y=195,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall5Dis",
		hiliteImage="UniEditWall5",
		image="UniEditWall5",
		disabledImage='UniEditWall5Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=5
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=270,y=195,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall6Dis",
		hiliteImage="UniEditWall6",
		image="UniEditWall6",
		disabledImage='UniEditWall6Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=6
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=255,y=165,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall7Dis",
		hiliteImage="UniEditWall7",
		image="UniEditWall7",
		disabledImage='UniEditWall7Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=7
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=235,y=145,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall8Dis",
		hiliteImage="UniEditWall8",
		image="UniEditWall8",
		disabledImage='UniEditWall8Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=8
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=255,y=125,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall9Dis",
		hiliteImage="UniEditWall9",
		image="UniEditWall9",
		disabledImage='UniEditWall9Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=9
		end
	}
	ti(butDir,t)
	t={
		type = "PUSHBUTTON",
		x=275,y=145,w=20,h=20,
		offsetX=0,offsetY=0,
		status="IMAGE",
		style = "MOUSETRACK",
		selectedImage="UniEditWall10Dis",
		hiliteImage="UniEditWall10",
		image="UniEditWall10",
		disabledImage='UniEditWall10Dis',
		textColor='#E6A541',
		onClick=function(a)
			wndButtonSwitchOff(a)
			wndButtonSwitchOn(butDir[wallP.dir+1])
			wallP.dir=10
		end
	}
	ti(butDir,t)


	ti(dlg,butDir[4])
	ti(dlg,butDir[3])
	ti(dlg,butDir[2])
	ti(dlg,butDir[1])
	ti(dlg,butDir[5])
	ti(dlg,butDir[6])
	ti(dlg,butDir[7])
	ti(dlg,butDir[8])
	ti(dlg,butDir[9])
	ti(dlg,butDir[10])
	ti(dlg,butDir[11])


	dlg.onGrabMouse=function(a)
		if wallP.mod==1 then
			setWall()
			else if wallP.mod==2 then
				wallDel()
			else
				wallInform()
			end
		end
		wndGrabMouse(a)
	end

	dlg.onLMDown=function()
		return 1;  --           .
	end

	wndCreate(dlg)
	for i=0,74 do
		wndLbAddText(listWall,mapNameByTile(i) ..'('..i..')')
	end
end

